﻿using Google.Apis.Sheets.v4.Data;
using Microsoft.Extensions.Configuration;
using Newtonsoft.Json.Linq;
using System;
using System.Buffers;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text.Json;
using System.Text.Json.Nodes;
using System.Threading.Tasks;
using TypeValidationLibrary;
using static System.Runtime.InteropServices.JavaScript.JSType;

class Program
{
    static async Task Main(string[] args)
    {
        //// read Configuration
        IConfigurationRoot config = new ConfigurationBuilder()
            .AddUserSecrets<Program>()
            .AddJsonFile("appsettings.json")
            .Build();

        // IConfigurationSection section = config.GetSection("GoogleSheets:Credentials");
        // JsonNode? jsonNode = WebUtilsLib.ConfigurationUtils.Serialize(section);
        // var credentialsJson = jsonNode.ToJsonString(new JsonSerializerOptions() { WriteIndented = true });
        // string spreadsheetId = config["GoogleSheets:SpreadsheetId"];
        // Console.WriteLine($"spreadsheetId = {spreadsheetId}");
        // Console.WriteLine($"credentialsJson = {credentialsJson}");

        WaferSearchOnSpreadsheetWrapper searcher = new WaferSearchOnSpreadsheetWrapper(config);
        searcher.Settings.Keys = null;
        string searchValue = "000015".TrimStart('0');
        var result = await searcher.Search(searchValue, (value, searchValue) => 
            string.CompareOrdinal(value?.TrimStart('0'), searchValue) == 0
        );
        if (result == null) {
            Console.WriteLine("Value not found");
            return;
        }
        // result
        Console.WriteLine("\tResult:");
        foreach (var kvp in result)
        {
            Console.WriteLine($"{kvp.Key}: {kvp.Value}");
        }
    }
}
