# MatInf: Multitenant Extendable Research Data Management System
Here is the source code repository for the MatInf - an open-source Web-based software that is aimed to provide free and flexible Research Data Management System for materials science.
Additional information regarding MatInf is available at [matinf.pro](https://matinf.pro/) website.

## Prerequisites
- ASP.Net Core 8 runtime or higher
- Microsoft SQL Server 2022 Express Edition or higher
- Windows, macOS, or Linux operating system

## Installation
- Clone the repository (contains source code and clear database in DB folder)
- Restore SQL Server database from a backup or create it with an attached script
- Build and deploy the system (use Microsoft Visual Studio or .NET SDK)
- Adjust application settings in appsettings.json w.r.t. database/mail server/authenification/options.

## Usage
Use any browser to access deployed web application.

## Documentation
Documentation is available in every instance under [Documentation](https://pub.matinf.pro/home/doc) link. 

## Examples
There is a **public playground** to test the system: [inf.mdi.ruhr-uni-bochum.de](https://inf.mdi.ruhr-uni-bochum.de/). Everybody is welcome to play with it using credentials, published at the home page.
Apart from this playground there is a **demo tenant**, that contains an example of [Bandgap](https://bg.imet-db.ru/) database based on the MatInf software.

## License
This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.
