﻿using Microsoft.AspNetCore.Authentication;

namespace TypeCoreLibrary;

/// <summary>
/// ContextPrecursor is a class containing object identifiers from a database (cheap to get)
/// and therefore can be a precursor to get (could be computationaly expensive) Context
/// </summary>
public class ContextPrecursor {
    /// <summary>
    /// validation Context (according TypeInfo.SettingsJson.ValidationContext)
    /// this property is enriched while processing through thwe type
    /// </summary>
    public string ValidationContext { get; set; }

    /// <summary>
    /// current object ObjectId
    /// </summary>
    public int ObjectId { get; init; }

    public object? CurrentObject { get; init; }

    /// <summary>
    /// Parent Objects Identifiers
    /// </summary>
    public int[] ParentObjectIds { get; init; }

    /// <summary>
    /// delegate to call to get Task<Context>
    /// </summary>
    public Func<ContextPrecursor, Task<Context>> GetContextAsync { get; init; }
}