using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc.ViewEngines;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.Data;
using System.Net;
using System.Reflection;
using System.Text;
using System.Web;
using TypeCoreLibrary;
using System.Net.Mime;
using Microsoft.VisualBasic;
using System.IO;

namespace WebApiTypeServiceTemplateCSharp.Controllers;

[Route("[controller]")]
public class VisualisationController : Controller
{
    private readonly ILogger<VisualisationController> _logger;

    public VisualisationController(ILogger<VisualisationController> logger)
    {
        _logger = logger;
    }

    /// <summary>
    /// Generates HTML to visualise the incoming document
    /// </summary>
    /// <returns>Html page to send to client</returns>
    [HttpPost]
    [Consumes(MediaTypeNames.Application.Octet)] // application/octet-stream
    [Produces(typeof(string))]
    public async Task<IActionResult> Post([FromBody] byte[] array)
    {
        (Stream inpuStream, string? filename) = Utilities.GetDataFromRequest(Request);
        // validation
        TypeValidatorResult vr = Utilities.Validate(inpuStream, filename);
        if (!vr)
            throw new Exception(vr.Message);

        return View((inpuStream, filename));
    }
}
